/*
 * The Legend Lives!
 *
 * Executable and source code are
 *
 *                 Copyright (C) 1995 by David M. Baggett
 *
 * All rights reserved, except as follows:
 * 
 *    Electronic redistribution is permitted, but only if not for profit.
 *    Specifically, you may provide copies in electronic form ONLY if you
 *    do not charge anything beyond the distribution media cost AND if you
 *    do not alter the source code in any way.
 *
 * Note that the author reserves all rights to derivative works and
 * products.  This includes ports and enhanced versions.  The author will
 * typically grant permission for these when asked, but this will be
 * dealt with on a case by case basis only.
 *
 */

modify Thing
	verIoAskfor(actor) = {}
	ioAskfor(actor, dobj) = {
		dobj.doAskfor( actor, self );
	}
	verDoAskfor(actor, io) = {
		"Surely, %you% can't think <<self.subjthedesc>> knows
		anything about it! ";
	}  
	verDoBuy(actor) = {}
	doBuy(actor) = {
		"Please specify who you want to pay for
		<<self.objthedesc(nil)>>.";
	}
	verDoPay(actor) = {
		"I doubt <<self.objthedesc(actor)>> is interested
		in your payment.";
	}
	doWhatis(actor) = {
		"You'll have to determine that through more direct means.";
	}
	verDoSmell(actor) = {}
	doSmell(actor) = { "It smells like an ordinary "; self.sdesc; "."; }
	verDoWave(actor) = { "Waving <<self.objthedesc(actor)>> doesn't seem to do much."; }
	verDoWaveat(actor, io) = { self.verDoWave(actor); }
	verIoWaveat(actor) = {}
	ioWaveat(actor, dobj) = { dobj.doWaveat(actor, self); }
	verDoBreak(actor) = { "I see no obvious way to do that."; }
	verDoBend(actor) = { "I see no obvious way to do that."; }
	verDoRub(actor) = {}
	doRub(actor) = { "Ok, you just rubbed <<self.objthedesc(actor)>>."; }
	verDoLick(actor) = {
		if (not isclass(self, Edible))
			"I hope you're not planning on running for
			office.  I'm writing this all down, you know.";
	}
	doLick(actor) = {	
		"It tastes pretty much like you'd expect ";
		self.adesc; " to taste."; 
	}
	verIoTicklewith(actor) = { "You're very strange, you know that?"; }
	verDoCount(actor) = {}
	doCount(actor) = { "You see one (1) "; self.sdesc; "."; }

	/*
	 * Map douse x with y to pour y on x
	 * This is fucked by verIo methods not getting dobj parameters
	 */
//	verDoDousewith(actor, io) = { self.verIoPouron(actor); }
//	doDousewith(actor, io) = { io.doPouron(actor, self); }
//	verIoDousewith(actor) = { self.verDoPouron(actor); }
//	ioDousewith(actor, dobj) = { dobj.ioPouron(actor, self); }
 
	verDoPouron(actor, io) = {
		caps(); self.subjthedesc; " is going to have to undergo
		a major state change first.";
	}
	verIoPouron(actor) = {}
	ioPouron(actor, dobj) = { dobj.doPouron(actor, self); }
	verDoPlay(actor) = { "Strange, the things you use to amuse yourself."; }
	verDoErase(actor) = { "Are you in the same universe I am?"; }
	verDoGuess(actor) = { "You have quite a way with words."; }
	verDoUse(actor) = { "You'll have to be a bit more explicit than that."; }
	verDoMake(actor) = { "You'll have to be a bit more explicit than that."; }
	verDoLight(actor) = { "I don't know how to light <<self.objthedesc(nil)>>."; }
	verDoRoll(actor) = { "I don't see any way to roll <<self.objthedesc(nil)>>."; }
	verDoUnroll(actor) = { "I don't see any way to unroll <<self.objthedesc(nil)>>."; }
	verDoPick(actor) = { "You're babbling, man!  Snap out of it!"; }
	verDoWake(actor) = { "\^<<self.subjthedesc>> <<self.is>> not asleep."; }
	verDoReset(actor) = { "How's the food there in the mental home?"; }
	verDoKick(actor) = { "Kicking <<self.objthedesc(actor)>> doesn't seem like a good idea."; }
	verDoPunch(actor) = { "Punching <<self.objthedesc(actor)>> doesn't seem like a good idea."; }

	verDoShootat(actor, io) = { self.verIoShootwith(actor); }
	doShootat(actor, io) = { self.ioShootwith(actor, io); }
	verIoShootat(actor) = { }
	ioShootat(actor, dobj) = { self.doShootwith(actor, dobj); }

	verDoShootwith(actor, io) = {}
	doShootwith(actor, io) = {
		if (io = self) {
			"You can't shoot <<self.objthedesc(actor)>> with itself.";
		}
		else if (io = raygun) {
			if(not raygun.scrambled) {
				"<GRAAAMN!>  A bolt of light shoots out of 
				<<raygun.objthedesc(actor)>>. ";

				self.scramble;
			}
			else {
				"<BZZZZZT!> A brilliant red beam
				shoots out of <<raygun.objthedesc(actor)>>. ";

				self.blast;
			}
		}
		else if (io = akmigun) {
			if (not akmigun.scrambled) {
				// EZ-Tech Blaser
				
				"The rings around the barrel of 
				<<io.objthedesc(actor)>> begin to pulsate like
				runway lights.  The gun starts making
				a furious humming sound, but nothing
				at all destructive happens.";
			}
			else {
				// Cheez Blaster
				
				"A pellet of pure Cheez shoots out of
				the end of <<io.objthedesc(nil)>>, glides around 
				<<self.objthedesc(nil)>> haphazardly, then
				zooms right back into the barrel,
				seemingly no worse for wear."; 
			}
		}
		else {
			"doShootwith: "; self.sdesc; " with "; io.sdesc;
		}
	}
	verIoShootwith(actor) = {
		"You can't shoot anything with <<self.objthedesc(actor)>>.";
	}
	ioShootwith(actor, dobj) = {
		dobj.doShootwith(actor, self);
	}
	scramble = {
		"\^<<self.subjthedesc>>";
		if (self.isplural)
			" seem";
		else
			" seems";
		" unaffected.";
	}
	blast = {
		"\^<<self.subjthedesc>>";
		if (self.isplural)
			" seem";
		else
			" seems";
		" unaffected.";
	}

	verDoPokewith(actor, io) = {}
	verIoPokewith(actor) = {
		"You can't poke anything with <<self.sdesc>>.";
	}
	doPokewith(actor, io) = {
		"Poking <<self.objthedesc(actor)>> with <<io.objthedesc(actor)>>
		\ doesn't seem to do much.";
	}
	verDoCutwith(actor, io) = {}
	verIoCutwith(actor) = {
		"You can't cut anything with <<self.objthedesc(actor)>>.";
	}
	doCutwith(actor, io) = {
		"You can't just go around slicing everything
		into pieces, you know!";
	}
	verDoCut(actor) = {
		"What do you want to cut <<self.objthedesc(actor)>> with?";
	}
	verDoPoke(actor) = {
		"What do you want to poke <<self.objthedesc(actor)>> with?";
	}
	verDoKnot(actor) = { "You have lost your mind."; }
	verDoUnknot(actor) = { "You have lost your mind."; }
	verDoBlow(actor) = {
		"I don't want to know.  I don't want to know...";
	}
	verDoPlant(actor) = {
		"I don't see what that could possibly accomplish.";
	}
	verDoPlantin(actor, io) = {
		self.verDoPlant(actor);
	}
	verIoPlantin(actor) = {
		"You can't plant anything in <<self.objthedesc(actor)>>.";
	}
	ioPlantin(actor, dobj) = { dobj.plantin(actor, self); }
	verDoRide(actor) = { "Eh?"; }
	verDoWatch(actor) = {
		"You won't learn anything by watching
		<<self.objthedesc(actor)>> that you can't learn
		just by examining <<self.objprodesc(actor)>>.";
	}
	verDoSwingin(actor) = { "You can't swing on that!"; }

	//
	// spraying (for the snake repellant)
	//
	verDoSpraywith(actor, io) = {
		"Now what would that accomplish?";
	}
	verIoSpraywith(actor) = {
		"\^<<actor.subjthedesc>> can't spray anything with
		<<self.objthedesc(actor)>>.";
	}

	verDoSprayat(actor, io) = { self.verIoSpraywith(actor); }
	verIoSprayat(actor) = { self.verDoSpraywith(actor, nil); }
	ioSprayat(actor, dobj) = { self.doSpraywith(actor, dobj); }

	//
	// Hack for typeVerb to allow "type password on keyboard".
	//
	canusealphanumorpassword(obj, loctype, silent) = {
		if (obj = TVpassword)
			return true;

		if (not silent)
			"that verb requires a double-quoted string,
			number, or special keyword.";

		return nil;
	}
;
